// stm8s103f3_loader.cs
using System;
using System.IO;
using System.IO.Ports;
using System.Threading;
using System.Collections.Generic;

public partial class stm8s103f3_loader
{
	
	public static void Main()   { 
		
		
		// инициализация COM порта
		if(SerialPort.GetPortNames().Length == 0)
		{	Console.WriteLine("COM порты не найдены");
			Console.ReadKey();
			return;}
		Console.WriteLine("Доступны COM порты:");
        foreach (string s in SerialPort.GetPortNames())
        {
            Console.WriteLine("   {0}", s);
			portName = s;
        }
        // создаем экземпляр COM-порта с настройками для общения с начальным загрузчиком
		sPort = new SerialPort(portName, 9600);
		sPort.ReadBufferSize = 20000;
		sPort.Open();		//открываем COM порт
		//queueBytes = new Queue<byte>();
		//readThread = new Thread(Read);
		//readThread.Start();		// запускаем поток чтения COM порта
		Console.WriteLine("Ждем байт 0x14 версии загрузчика. Нажми кнопку сброса на плате.");
		while(unready)
		{
			//while(queueBytes.Count == 0){}  rx_byte = queueBytes.Dequeue();
			while(sPort.BytesToRead == 0){}  rx_byte = (byte)sPort.ReadByte(); // ждем версию загрузчика
			if(rx_byte == 0x14)
			{
				Console.WriteLine("Принят байт 0x{0:X2} от boot_OPTION", rx_byte);
				Console.WriteLine("Отправляем размер 0x{0:X2} байт блока", first_block.Length);		
				byte[] txBytes = {(byte)first_block.Length};
				sPort.Write(txBytes, 0, 1); // отправляем размер дампа
				unready = false;
			}

		}//while(unready)

		sPort.Write(first_block, 0, first_block.Length);				// отправляем сам дамп
		Thread.Sleep(500); // подождем пока очистится буфер передачи

		// переходим на общение с отправленным дампом, меняем скорость COM-порта
		sPort.BaudRate = 128000;
		 // где-то здесь не плохо бы очистить приемный буфер COM-порта
		
		int i = 0x0000;	// адрес первого блока
		//queueBytes.Clear(); // очистим очередь приема
		for (; i <= 0x9FFF; ){
			Console.WriteLine();
			//Console.WriteLine("${0:X4} ", i);
			
			int j = 0x003F;  // размер блока 64 байта
		
			byte[] txBytes = {(byte)(i>>8), (byte)i};
			sPort.Write(txBytes, 0, txBytes.Length); // отправляем адрес текущего блока

			Thread.Sleep(20000*j/sPort.BaudRate); // 2994 для sPort.BaudRate == 64000 и j == 0x1FFF

			for (; j >= 0x0000; i++, j-- ){ // принимаем 64 байта
				//while(queueBytes.Count == 0){}  rx_byte = queueBytes.Dequeue();
				while(sPort.BytesToRead == 0){}  rx_byte = (byte)sPort.ReadByte();
				//if((j+1) % 32 == 0) Console.Write("\n${0:X4} ", i);
				if((j+1) % 16 == 0) Console.Write("\n${0:X4} ", i);
				Console.Write("${0:X2} ", rx_byte);
				//if (j==0x0000 | j==0x0010 | j==0x0020 | j==0x0030) Console.WriteLine(); // 16 байт в строке
				//if (j==0x0000 | j==0x0020 ) Console.WriteLine(); // 32 байта в строке
			}
		}//for (; i <= 0x9FFF; )
		Console.WriteLine();
		
		Console.Write("\nПодождите идет повторное чтение памяти с записью в файл.\n");
		
		// повторим в файл
		i = 0x0000;	// адрес первого блока
		//queueBytes.Clear(); // очистим очередь приема
		for (; i <= 0x9FFF; ){
			//Console.WriteLine();
			stringMemoryMap = stringMemoryMap + "\n";
			//Console.WriteLine("${0:X4} ", i);
			
			int j = 0x003F;  // размер блока 64 байта
		
			byte[] txBytes = {(byte)(i>>8), (byte)i};
			sPort.Write(txBytes, 0, txBytes.Length); // отправляем адрес текущего блока

			Thread.Sleep(20000*j/sPort.BaudRate); // 2994 для sPort.BaudRate == 64000 и j == 0x1FFF

			for (; j >= 0x0000; i++, j-- ){ // принимаем 64 байта
				//while(queueBytes.Count == 0){}  rx_byte = queueBytes.Dequeue();
				while(sPort.BytesToRead == 0){}  rx_byte = (byte)sPort.ReadByte();
				//if((j+1) % 32 == 0) Console.Write("\n${0:X4} ", i);
				if((j+1) % 16 == 0) stringMemoryMap = stringMemoryMap + String.Format("\n${0:X4} ", i);
				//if((j+1) % 16 == 0) Console.Write("\n${0:X4} ", i);
				stringMemoryMap = stringMemoryMap + String.Format("${0:X2} ", rx_byte);
				//Console.Write("${0:X2} ", rx_byte);
				//if (j==0x0000 | j==0x0010 | j==0x0020 | j==0x0030) Console.WriteLine(); // 16 байт в строке
				//if (j==0x0000 | j==0x0020 ) Console.WriteLine(); // 32 байта в строке
			}
		}//for (; i <= 0x9FFF; )
		stringMemoryMap = stringMemoryMap + "\n";

		
		StreamWriter fstr_out;

		try {
			fstr_out = new StreamWriter("stringMemoryMap.txt");
		}
		catch(IOException exc) {
			Console.WriteLine(exc.Message);
			Console.ReadLine();
			return;
		}
		
			try {
				fstr_out.WriteLine(stringMemoryMap);
			}
			catch(IOException exc) {
				Console.WriteLine(exc.Message);
				Console.ReadLine();
				return;
			}			

		fstr_out.Close();
		
		Console.Write("\nГотово.\n");
		
		//readThread.Join();
		sPort.Close();
		Console.ReadKey(); return;
    } // Main();

	/*
	    public static void Read()
		{
			while (inCycle)
			{
				try
				{
					if(sPort.BytesToRead > 0){
					queueBytes.Enqueue((byte)sPort.ReadByte());
					}
				}
				catch (TimeoutException) { }
			}
		}*/
	    
	//public static Thread readThread;
	//public static Queue<byte> queueBytes;
	public static string stringMemoryMap = "";
	public static bool inCycle = true;
	public  static byte rx_byte = 0x00;
	public  static bool unready = true;
	public  static string fileName;	
	public static SerialPort sPort;
	public static string portName;
   public readonly static byte[] first_block = { 0xC6, 
0x20, 0x08, 0x50, 0x1B, 0x72, 0x07, 0x50, 0x1B, 0x72, 0xF2, 0x26, 0x5A, 0x90, 0x5C, 0xFB, 0x30, 
0x52, 0x0F, 0x72, 0x31, 0x52, 0xC7, 0xF6, 0x40, 0x00, 0xAE, 0x90, 0x36, 0x52, 0x20, 0x35, 0x08, 
0x50, 0x1A, 0x72, 0x07, 0x50, 0x1A, 0x72, 0x97, 0x31, 0x52, 0xC6, 0xFB, 0x30, 0x52, 0x0B, 0x72, 
0x95, 0x31, 0x52, 0xC6, 0xFB, 0x30, 0x52, 0x0B, 0x72, 0x35, 0x52, 0x0C, 0x35, 0x32, 0x52, 0x01, 
0x35, 0x33, 0x52, 0x00, 0x35 };

	
}
// stm8s103f3_loader.cs